var EXPORTED_SYMBOLS = ['CProcess'];

var CProcess = function(){};
var ClassConstructor = CProcess;

/* INIT TO CALL FROM CHILD CONSTRUCTOR */
	ClassConstructor.prototype.init = function(engine, ST, doc, url, RendererConstructor, ParserConstructor){
			
		/* sub objects */
			this.Renderer = new RendererConstructor(this);
			this.Parser   = new ParserConstructor(this);
			
		/* save these variables */
			this.ST = ST;
			this.host_id = doc.domain;
			this.host = doc.domain;
			this.doc = doc;
			this.url = url;
			this.engine = engine;
			
		/* iteration and destruction */
			this.func = function(o){return function(){o.Process()}}(this);
			this.destroy = function() { this.func = null; };
			
		/* uri object for operate with cookie */
			this.uri_object = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI("http://"+doc.domain+"/", null, null);
			
		/* inner variables */
			this.handled = false;
			
			this.current = {
				'keyword': null,
				'page': null,
				'resperpage': null,
				'date': null
				};
		}
		
/* PARSE */
	ClassConstructor.prototype.NextIteration = function(message) {
			if (message) this.ST.debug(6, message);
		}
	ClassConstructor.prototype.Process = function(switched_on) {
			try
			{
				/* before checking weather extension is switched off or not we must read cookie anyway because cookie must be read at the moment the page is loaded */
				if (!switched_on) this.current.resperpage = this.Parser.getResperpage();
				
				if (!this.is_iterative && this.handled) return this.NextIteration('Already handled'); /* document already handled */
				
				if (!this.ST.state) return this.NextIteration('Extension is switched off'); /* extension is switched off */
				if (this.doc.getElementById('similarius_span')) { this.handled = true; return this.NextIteration('Already handled'); };
				
				/* parse current results and get previous results */
				var elems = this.Parser.Parse();
				
				/* draw position numbers and dynamics */
				if (this.is_iterative) this.handled = false; /* to mark results with id="similarius_span" */
				for (var i = 0; i < elems.length; i++)
				{
					var domain = elems[i].url.replace(/^https?:\/\//, '').replace(/\/.*$/, '');
					var green_url_lasttag = elems[i].green_url_lasttag;
					if (green_url_lasttag)
					{
						var e = this.doc.createElement('span');
						if (!this.handled)
						{
							this.handled = true;
							e.id = 'similarius_span';
						};
						e.appendChild(this.doc.createTextNode(' - '));
						var a = this.doc.createElement('a');
						a.style.color = '#660000';
						a.setAttribute('href', 'http://www.similarius.com/site/'+encodeURIComponent(domain));
						a.appendChild(this.doc.createTextNode('Get similar sites'));
						e.appendChild(a);
						
						if (green_url_lasttag.nextSibling)
							green_url_lasttag.parentNode.insertBefore(e, green_url_lasttag.nextSibling);
						else
							green_url_lasttag.parentNode.appendChild(e);
					};
					
				}
				
				return this.NextIteration();
				
			}
			catch (e)
			{
				/* should we alert with the error? */
				//if (this.ST.getBoolPref('alerterrors')) alert(e);
			};
		}
	
