var EXPORTED_SYMBOLS = ['CBingProcess'];

Components.utils.import("resource://similarius/bing/renderer.jsm");
Components.utils.import("resource://similarius/bing/parser.jsm");

/* constructor */
	var CBingProcess = function(p, doc, url) {
			this.init('bing', p, doc, url, CBingRenderer, CBingParser);
			this.results_count_div_id = 'count';
			this.current['country'] = null;
		}
	var ClassConstructor = CBingProcess;

/* inherit from CProcess */
	Components.utils.import("resource://similarius/base/process.jsm");
	(function(c, p){ var F = function(){}; F.prototype = p.prototype; c.prototype = new F(); c.prototype.constructor = c; })(ClassConstructor, CProcess);

/* methods */
	ClassConstructor.prototype.getCurrentCountry = function() {
			/* get cookies */
			var cookie = this.ST.cookieSvc.getCookieString(this.uri_object, null); 
			if (cookie === null) return 10;

			/* check results per page */
			var cookie_matches1 = cookie.match(/(^|;)\s*_FP=([^;]+)(;|$)/);
			if (!cookie_matches1) return 'default';
			var cookie_matches2 = cookie_matches1[2].match(/(^|&)mkt=([\w-]+)(&|$)/);
			if (!cookie_matches2) return 'default';
			return cookie_matches2[2];
		}
	
