var EXPORTED_SYMBOLS = ['CYahooParser'];


var CYahooParser = function(p){this.p=p};
var ClassConstructor = CYahooParser;

/* inherit CYahooParser from CParser */
Components.utils.import("resource://similarius/base/parser.jsm");
(function(c,p){var f=function(){};f.prototype=p.prototype;c.prototype=new f();c.prototype.constructor=c})(CYahooParser,CParser);

ClassConstructor.prototype.getKeyword = function(){
		var keywordInput = this.p.doc.getElementById('yschsp');
		if (keywordInput) return keywordInput.value;
		
		var keywordInputs = this.p.doc.getElementsByTagName('input')
		for (var i = 0; i < keywordInputs.length; i++)
			if (keywordInputs[i].type && keywordInputs[i].type == 'text' && keywordInputs[i].value)
				return keywordInputs[i].value;
		return null;
	}

ClassConstructor.prototype.getPage = function(){
		var _pgdiv = this.p.doc.getElementById('pg');
		if (!_pgdiv) return null;
		var _strong = _pgdiv.getElementsByTagName('strong');
		if (!_strong || !_strong.length) return null;
		if (_strong[0].textContent) return _strong[0].textContent.replace(/\D/, '');
	}

ClassConstructor.prototype.getResperpage = function(){
		/* try to see it on query string */
		var getstring = this.p.url.replace(/^[^\/]*\//, '').replace(/#.*$/, '');
		var matches = getstring.match(/\bn=(\d+)\b/);
		if (matches)
		{
			var resperpage = parseInt(matches[1],10);
			var available_resperpages = [10,15,20,30,40,100];
			for (var i = 0; i < available_resperpages; i++)
				if (resperpage == available_resperpages[i])
					return resperpage;
		};
		
		/* get cookies */
		var cookie = this.p.ST.cookieSvc.getCookieString(this.p.uri_object, null); 
		if (cookie === null) return 10;

		/* check results per page */
		var cookie_matches1 = cookie.match(/\bsB=([^;]+)(;|$)/);
		if (!cookie_matches1) return 10;
		var cookie_matches2 = cookie_matches1[1].match(/(^|&)n=(\d+)(&|$)/);
		if (cookie_matches2) return cookie_matches2[2];
		
		return 10;
	}

ClassConstructor.prototype.getStart = function(){
		var getstring = this.p.url.replace(/^[^\/]*\//, '').replace(/#.*$/, '');
		var matches = getstring.match(/\bb=(\d+)\b/);
		if (!matches) return null;
		var start = parseInt(matches[1],10);
		return start ? start - 1 : 0;
	}

ClassConstructor.prototype._search_is_regular1 = function(){
		/* check if "web" tab is active */
		var _flt = this.p.doc.getElementsByClassName('flt');
		if (!_flt || !_flt.length) return true;
		var _a = _flt[0].getElementsByTagName('a');
		if (!_a || !_a.length) return false;
		if (/\bactive\b/.test(_a[0].className)) return true;
		return false;
	}

ClassConstructor.prototype._search_is_regular2 = function() {
		/* "the Web" */
		var _sf = this.p.doc.getElementById('sf');
		if (!_sf) return true;
		if (!_sf.elements) return true;
		for (var i = 0; i < _sf.elements.length; i++)
		{
			if (_sf.elements[i].name != 'rd') continue;
			this.p.ST.debug(5, 'rd found');
			return (_sf.elements[i].value && _sf.elements[i].value != 'r1') ? false : true;
		};
		return true;
	}

ClassConstructor.prototype._search_is_regular3 = function() {
		/* filers */
		var _ss = this.p.doc.getElementById('ss');
		if (!_ss) return true;
		return !(_ss.getElementsByClassName('ss-remove').length > 0);
	}

ClassConstructor.prototype.SearchIsRegular = function(){
		return true;
		if (!this._search_is_regular1()) { this.p.ST.debug(5, 'not regular (1)'); return false; };
		if (!this._search_is_regular2()) { this.p.ST.debug(5, 'not regular (2)'); return false; };
		if (!this._search_is_regular3()) { this.p.ST.debug(5, 'not regular (3)'); return false; };
		return true;
	}

ClassConstructor.prototype.Parse = function(){
		var elems = [];
		
		var _div = this.p.doc.getElementById('web');
		if (!_div) return elems;
		var _ols = _div.getElementsByTagName('ol');
		if (!_ols || !_ols.length) return elems;
		var arr = _ols[0].getElementsByTagName('li');
		
		for (var i = 0; i < arr.length; i++)
		{
			/* find <div class="res"> */
			var elem_div = null;
			var elem_divs = arr[i].getElementsByTagName('div');
			for (var j = 0; j < elem_divs.length; j++)
				if (/\bres\b/.test(elem_divs[j].className))
					{ elem_div = elem_divs[j]; break; };
			//if (!elem_div)
			//	if (arr[i].childNodes.length == 1)
			//		elem_div = arr[i].firstChild;
			
			/* filters */
			if (!elem_div) continue;
			if (/\bsc_news\b/.test(elem_div.className)) continue;

			/* main url */
			var mainURL = null;
			var headers = (elem_div ? elem_div : arr[i]).getElementsByTagName('h3');
			if (headers.length)
			{
				var links = headers[0].getElementsByTagName('a');
				if (links.length) mainURL = links[0].href;
			};
			if (!mainURL || mainURL.indexOf('http://'+this.p.host+'/search') === 0 || mainURL.indexOf('https://'+this.p.host+'/search') === 0) continue;
			
			var green_url_lasttag = null;
			var green_url_tags = (elem_div && elem_div.getElementsByClassName)
				? elem_div.getElementsByClassName('url')
				: null;
			if (green_url_tags && green_url_tags.length)
				for (var j = green_url_tags.length - 1; j >= 0; j--)
					if (green_url_tags[j].nodeName == 'SPAN')
						{ green_url_lasttag = green_url_tags[j]; break; };
			
			elems.push({'url': mainURL, 'li': arr[i], 'div': elem_div, 'green_url_lasttag': green_url_lasttag});
		};
		
		return elems;
	}
